/*
 * contacts.cpp
 *
 * reading of contacts and calls using AT commands
 *
 * Copyright (c) 2002-2003 by Michal Cihar <cihar@email.cz>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * In addition to GNU GPL this code may be used also in non GPL programs but
 * if and only if programmer/distributor of that code receives written
 * permission from author of this code.
 *
 */
/* $Id: contacts.cpp,v 1.9 2003/05/09 16:52:46 michal Exp $ */
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
/*
#include <ctype.h>
#include <time.h>
*/
#include <qstring.h>

#include "contacts.h"
#include "modem.h"
#include "mobile.h"
#include "common.h"
#include "logging.h"

ushort text2int(char *text) {
    int result=0;
    if (text[2]>57)
        result+=text[2]-55;
    else
        result+=text[2]-48;
    result=result<<4;
    if (text[3]>57)
        result+=text[3]-55;
    else
        result+=text[3]-48;
    result=result<<4;
    if (text[0]>57)
        result+=text[0]-55;
    else
        result+=text[0]-48;
    result=result<<4;
    if (text[1]>57)
        result+=text[1]-55;
    else
        result+=text[1]-48;
    return result;
}

ContactData *get_contacts(int from, int to) {
    char answer[20000], raw[200], number[100], *data;
    ushort *binary;
    int count=0, i, len;
    modem_cmd("AT+CSCS=\"UCS2\"\r\n", answer, sizeof(answer), 50, NULL);
    ContactData *cont;

    sprintf(raw, "AT+CPBR=%d,%d\r\n", from, to);
    modem_cmd(raw, answer, sizeof(answer), 500, NULL);

    data = answer;
    while( (data = strchr(data,'"')) != NULL) data[0] = ' ';

    data = answer;
    /* how many contacts are listed? */
    while( (data = strstr(data,"+CPBR:")) != NULL) {
        count++;
        data++;
    }

    message(MSG_INFO,"Read %d contacts", count);

    /* allocate array for storing messages */
    cont = (ContactData *)malloc((count + 1) * sizeof(ContactData));
    chk(cont);
    cont[count].pos = -1; /* end symbol */

    /* fill array */
    data = answer;
    count = 0;
    while( (data = strstr(data,"+CPBR:")) != NULL) {
        sscanf(data, "+CPBR: %d, %s ,%d, %s ", &(cont[count].pos), number, &i, raw);
        data++;

        chk(cont[count].number = strdup(number));

        len = strlen(raw);
        if (strncmp("E1004FE0EF000301", raw, 16) == 0) {
            raw[0] = 0;
            cont[count].name = new QString();
        } else {
            len >>= 2;

            chk(binary = (ushort *)malloc(len * sizeof(ushort)));

            for(i=0; i<len; i++) {
                binary[i] = text2int (raw + (4*i));
            }

            cont[count].name = new QString();
            cont[count].name->setUnicodeCodes(binary, len);
        }
        count++;
    }

    modem_cmd("AT+CSCS=\"GSM\"\r\n", answer, sizeof(answer), 50, NULL);

    return cont;
}

int select_phonebook(const char *pbtype) {
    char answer[100], cmd[100];

    snprintf(cmd, sizeof(cmd)-1, "AT+CPBS=\"%s\"\r\n", pbtype);
    modem_cmd(cmd, answer, sizeof(answer), 50, NULL);

    if (strstr(answer, "ERROR") != NULL) return 0;
	return 1;
}
